% ----------------------------------------------------------------------- %
% % gaussdev function                                                   % %
% % obtain a normal gaussian deviate                                    % % 
% ----------------------------------------------------------------------- %

function [g, calc] = gaussdev(calc)

if calc.gaussdevreset(calc.obs, 1) == 1; % if the random number generator seed has been reset, start freshly;
    calc.alternate(calc.obs, 1) = 0;
    calc.gaussdevreset(calc.obs, 1) = 0;
end;

if calc.alternate(calc.obs, 1) == 0;
    
    calc.alternate(calc.obs, 1) = 1;
    
    r = 2;
    while r >= 1;
        [v1, calc] = frand(calc);
        v1 = 2 * v1 - 1;
        [v2, calc] = frand(calc);
        v2 = 2 * v2 - 1;
        r = v1 * v1 + v2 * v2;
    end;
    
    factor = sqrt(-2 * log(r) / r);
    
    calc.gaussdev1(calc.obs, 1) = v1 * factor;
    calc.gaussdev2(calc.obs, 1) = v2 * factor;
    
    g = calc.gaussdev1(calc.obs, 1);

else
    
    calc.alternate(calc.obs, 1) = 0;
    g = calc.gaussdev2(calc.obs, 1);

end;